"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.monitor = void 0;
const rxjs_1 = require("rxjs");
function monitor(streamMonitor) {
    return (source$) => new rxjs_1.Observable((observer) => {
        streamMonitor.isActive = true;
        streamMonitor.error = null;
        streamMonitor.pumps = 0;
        const wrapper = {
            next: (value) => {
                streamMonitor.pumps += 1;
                observer.next(value);
            },
            error: (error) => {
                streamMonitor.isActive = false;
                streamMonitor.error = error;
                observer.error(error);
            },
            complete: () => {
                streamMonitor.isActive = false;
                observer.complete();
            },
        };
        return source$.subscribe(wrapper);
    });
}
exports.monitor = monitor;
