"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.monitorPromise = void 0;
function monitorPromise(monitor, promise) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            monitor.isActive = true;
            const result = yield promise;
            monitor.isActive = false;
            return result;
        }
        catch (error) {
            monitor.isActive = false;
            monitor.error = error;
            return null;
        }
    });
}
exports.monitorPromise = monitorPromise;
